%define releasedate	20140724
%define rel		3

%define major		4
%define minor		3
%define update		0
%define dotver		%{major}.%{minor}
%define sourcebasename	tbb%{major}%{minor}_%{releasedate}oss

%define libmajor	2
%define libname		%mklibname %{name} %{libmajor}
%define devname		%mklibname %{name} -d

Summary:	Library to abstract low-level threading details
Name:		tbb
Version:	%{dotver}
Release:	%mkrel 1
License:	GPLv2 with exceptions
Group:		System/Libraries
URL:		http://threadingbuildingblocks.org/
Source0:	http://threadingbuildingblocks.org/sites/default/files/software_releases/source/tbb%{major}%{minor}_%{releasedate}oss_src.tar.xz

# These are downstream sources.
Source1:	tbb.pc
Source2:	tbbmalloc.pc
Source3:	tbbmalloc_proxy.pc

# (Fedora) Propagate CXXFLAGS variable into flags used when compiling C++.
# This so that %%optflags are respected.
Patch1:		tbb-4.3-mga-cxxflags.patch
# (Fedora) Replace mfence with xchg (for 32-bit builds only) so that TBB
# compiles and works supported hardware.  mfence was added with SSE2,
# which we still don't assume.
Patch2:		tbb-4.0-mfence.patch
# (Fedora) Don't snip -Wall from C++ flags.  Add -fno-strict-aliasing, as that
# uncovers some static-aliasing warnings.
# Related: https://bugzilla.redhat.com/show_bug.cgi?id=1037347
Patch3:		tbb-4.3-fdr-dont-snip-Wall.patch

BuildRequires:	libstdc++-devel
# We need "arch" and "hostname" binaries:
BuildRequires:	util-linux
BuildRequires:	net-tools

%description
Threading Building Blocks (TBB) is a C++ runtime library that
abstracts the low-level threading details necessary for optimal
multi-core performance.  It uses common C++ templates and coding style
to eliminate tedious threading implementation work.

TBB requires fewer lines of code to achieve parallelism than other
threading models.  The applications you write are portable across
platforms.  Since the library is also inherently scalable, no code
maintenance is required as more processor cores become available.

%package -n %{libname}
Summary:	Library to abstract low-level threading details
Group:		System/Libraries


%description -n %{libname}
Threading Building Blocks (TBB) is a C++ runtime library that
abstracts the low-level threading details necessary for optimal
multi-core performance.  It uses common C++ templates and coding style
to eliminate tedious threading implementation work.

TBB requires fewer lines of code to achieve parallelism than other
threading models.  The applications you write are portable across
platforms.  Since the library is also inherently scalable, no code
maintenance is required as more processor cores become available.

%package -n %{devname}
Summary:	The Threading Building Blocks C++ headers and shared development libraries
Group:		Development/Libraries
Requires:	%{libname} = %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}

%description -n %{devname}
Header files and shared object symlinks for the Threading Building
Blocks (TBB) C++ libraries.

%package doc
Summary:	The Threading Building Blocks documentation
Group:		Documentation

%description doc
PDF documentation for the user of the Threading Building Block (TBB)
C++ library.


%prep
%setup -q -n %{sourcebasename}
%apply_patches

%build
%setup_compile_flags
%make tbb_build_prefix=obj

for file in %{SOURCE1} %{SOURCE2} %{SOURCE3}; do
    sed 's/_FEDORA_VERSION/%{major}.%{minor}.%{update}/' ${file} \
        > $(basename ${file})
done

%install
rm -rf %buildroot
mkdir -p %{buildroot}%{_libdir}
mkdir -p %{buildroot}%{_includedir}

pushd build/obj_release
    for file in libtbb{,malloc{,_proxy}}; do
        install -p -D -m 755 ${file}.so.%{libmajor} %{buildroot}%{_libdir}
        ln -s ${file}.so.%{libmajor} %{buildroot}%{_libdir}/${file}.so
    done
popd

pushd include
    find tbb -type f -name \*.h -exec \
        install -p -D -m 644 {} %{buildroot}/%{_includedir}/{} \
    \;
popd

for file in %{SOURCE1} %{SOURCE2} %{SOURCE3}; do
    install -p -D -m 644 $(basename ${file}) \
    %{buildroot}/%{_libdir}/pkgconfig/$(basename ${file})
done

%files -n %{libname}
%doc COPYING doc/Release_Notes.txt
%{_libdir}/lib*.so.%{libmajor}

%files -n %{devname}
%doc CHANGES
%{_includedir}/tbb/
%{_libdir}/lib*.so
%{_libdir}/pkgconfig/*.pc

%files doc
%doc doc/html/*


%changelog
* Fri Aug 07 2015 bb <bb> 4.3-1pclos2015
- import into pclos from mga
